procedure CopySmaller (var InvenBook,
                           UpdateBook {室/室}:Book;
                       var Inventory {室},
                           Update {室},
                           NewInven {室}:BookFile);

begin {CopySmaller}
 if InvenBook.StockNum < UpdateBook.StockNum then
   begin  {<}
     Write (NewInven, InvenBook);  {஢ 
                                            InvenBook.}
     Read (Inventory, InvenBook)
   end {<}
 else if InvenBook.StockNum > UpdateBook.StockNum then
   begin {>}
     Write (NewInven, UpdateBook); {஢ 
                                            UpdateBook.}
     Read (Update, UpdateBook)
   end {>}
 else
   begin {=}
     UpdateBook.Quantity := UpdateBook.Quantity +
                            InvenBook.Quantity;
     Write (NewInven, UpdateBook);   {஢ 
                                UpdateBook  .}
     Read (Inventory, InvenBook);    {뢠 
                                                ᥩ.}
     Read (Update, UpdateBook)
   end {=}
end; {CopySmaller.}

procedure Merge (InvenName, UpdateName, NewInvenName
                                      {室} : string);
{
 ꥤ  䠩 Inventory  Update  䠩
 NewInven.
 ।᫮ : 譨   䠩 ᮤঠ
                ࠬ.  Inventory  Update
               --  騥 䠩,
               ஢   ࠬ
                騥 ᨣ쭮 ⪮.
 ᫮ :  ,  ⮫쪮 
               Inventory  Update, ࠧ 
                NewInven. ᫨  
                  䠩, 
               Quantity  ᥩ 㬬, 
               ⠫    Update.
                NewInven   
               ࠬ  蠥 ᨣ쭮 ⪮.
 뢠    : 楤 CopySmaller.
}

  var
    Inventory,              { 䠩  ୮
                                            }
    Update,                 {䠩   ଠ樥}
    NewInven : BookFile;    { 䠩  ୮
                                            }
    InvenBook,              {⥪  䠩
                                             Inventory}
    UpdateBook : Book;    {⥪  䠩 Update}

begin {Merge}
  {
   ⮢ 䠩 Inventory  Update  뢠, 
   䠩 NewInven  .
  }
  Assign (Inventory, InvenName);
  Assign (Update, UpdateName);
  Assign (NewInven, NewInvName);
  Reset (Inventory); Reset (Update); Rewrite (NewInven);

  {뢠 ࢮ   Inventory  Update.}
  Read (Inventory, InvenBook);
  Read (Update, UpdateBook);
  {
   ஢  ᥩ  䠩 Inventory 
   Update  NewInven.
  }
  while (InvenBook.StockNum <> Sentinel) or
        (UpdateBook.StockNum <> Sentinel) do
    CopySmaller (InvenBook, UpdateBook, Inventory,
                 Update, NewInven);

  {  NewInven ᨣ쭮 ⪨.}
  Write (NewInven, InvenBook):

  WriteLn ('ﭨ 䠩 襭.');
  Close (Inventory);
  Close (Update);
  Close (NewInven)
end;  {Merge}
