unit EnterData;
{
 ন 楤 Restore, PopUpWindow, ReadLnBool
  EnterInt. ६ CountBad 㦨  
 ᫠ 맮 楤 EnterInt  ⨬
 .
}
interface
  uses Crt;          {EnterData --   Crt.}

    var
      CountBad : Integer;   {⨬ }

    procedure Restore;
    {
     樨 ⮡ࠦ   ࠭  頥
     ࠭.
     Pre : 
     Post: ࠭ 饭.
    }

    procedure PopUpWindow (Prompt {室} : string;
                           WinSize,
                           WinColor {室} : Integer);
    {
     ⮡ࠦ     
      .
     Pre : 
     Post: ⮡ࠦ   梥 WinColor,
           ᮤঠ饥 ᮮ饭 Prompt.  ⮬
           筮     
           WinSize ᨬ.
    }

        procedure ReadLnBool (var BoolVal {室} : Boolean);
    {
     뢠 祭 ⨯ Boolean (।⠢
     ᨬ T  F)  ࠬ BoolVal.
     Pre : 
     Post: BoolVal ⠭  True, ᫨ 뫠
           ⠭ 㪢 T  t;  ⨢ 砥
           BoolVal ⠭  False.
    }

    procedure EnterInt (MinN, MaxN {室} : Integer;
                        var N {室} : Integer);
    {
     뢠  N 楫᫥ 祭, ਭ饥
      MinN..MaxN. ᫨  
     ⨬, 祭 CountBad 㢥稢  1.
     Pre : MinN  MaxN  । 祭.
     Post: 頥 १ ࠬ N ࢮ ⠭
           祭  MinN  MaxN, ᫨ ᫮
           MinN <= MaxN ᮡ;  ⨢ 砥 N
            । 祭  CountBad
           㢥稢  1.
    }

implementation
  { ᫥ ⠢ 楤 Restore 
   PopUpWindow  . 9.4.}

  procedure ReadLnBool (var BoolVal {室} : Boolean);
    var
      NextChar : Char;           {ᨬ }

  begin {ReadLnBool}
    repeat
      Write (' ᨬ T  F> ');
      ReadLn (NextChar);
      NextChar := Upcase(NextChar);
      BoolVal := (NextChar = 'T')
    until (NextChar = 'T') or (NextChar = 'F')
  end; {ReadLnBool}

  procedure EnterInt (MinN, MaxN {室} : Integer;
                      var N {室} : Integer);
    var
      InRange : Boolean;  {䫠, ࠢ騩 横}

  begin {EnterInt}
    if MinN <= MaxN then
      InRange := False    {⨬ 祭  
                                              ⠭.}
    else
      begin
        WriteLn ('訡 - ⨬ ');
        CountBad := CountBad + 1;
        InRange := True    {ய 横  .}
      end; {if}

    {뢠 த   ४⭮
     祭.}
    while not InRange do
      begin
        Write (' 楫᫥ 祭  ');
        Write (MinN :1, '  ', MaxN :1, '> ');
        ReadLn (N);
        InRange := (MinN <= N) and (N <= MaxN)
      end {while}
  end; {EnterInt}

begin {EnterData}
  CountBad := 0  {⨬ 祭  뢠}
end. {EnterData}
