unit EntryADT;
{ࠪ ⨯   㭪 ⥫䮭 ࠢ筨}

interface

  type
    KeyType = string[20];   {⨯ 祢  㭪}
    StringType = string[12];

    Entry = record
              Name : KeyType;          {祢 .}
              Number : StringType
            end; {Entry}

    procedure Init (var AnEntry {室} : Entry;
                    AName : KeyType;
                    ANumber : StringType);

    procedure ReadEntry (var AnEntry {室} : Entry;
                         var InFile {室} : Text;
                         FileName {室} : string);

    function GetNumber (AnEntry : Entry): StringType;

    function GetName (AnEntry : Entry): KeyType;

    function EqualTo (AnEntry, Entry2 : Entry) : Boolean;

    procedure DisplayEntry (AnEntry {室} : Entry);

    implementation

    procedure Init (var AnEntry {室} : Entry;
                    AName : KeyType;
                    ANumber : StringType);
    {
      㭪 ࠢ筨, ᮤঠ騩 祭
     AName  ANumber.
     ।᫮ :  AName  ANumber ।.
     ᫮ :  AName  ANumber ᮤঠ
                     㭪 ࠢ筨.
    }
    begin {Init}
      AnEntry.Name := AName;
      AnEntry.Number := ANumber
    end; {Init}

    procedure ReadEntry (var AnEntry {室} : Entry;
                         var InFile {室} : Text;
                         FileName {室} : string);
    {
     뢠  㭪 ࠢ筨  
     ⥫䮭 .
     ।᫮ :    InFile   祭
                     FileName ।.
     ᫮ :      ⠭  㭪
                     ࠢ筨.
    }
    begin {ReadEntry}
      if FileName = '' then
        begin { }
          Write ('> ');
          ReadLn (AnEntry.Name);
          Write ('> ');
          ReadLn (AnEntry.Number)
        end { }
      else
        begin { InFile}
          ReadLn (InFile, AnEntry.Name);
          ReadLn (InFile, AnEntry.Number)
        end { InFile}
    end; {ReadEntry}

    function GetNumber (AnEntry : Entry) : StringType;
    {
     頥 ⥫䮭 , ᮤঠ騩
      㭪 ࠢ筨.
     ।᫮ : 祭 AnEntry ।.
     ᫮ : 頥 ⥫䮭 .
    }
    begin {GetNumber}
      GetNumber := AnEntry.Number
    end; {GetNumber}

    function GetName (AnEntry : Entry) : KeyType;
    {
     頥 , ᮤঠ饥  㭪 ࠢ筨.
     ।᫮ : 祭 AnEntry ।.
     ᫮ : 頥 .
    }
    begin {GetName}
     GetName := AnEntry.Name
    end; {GetName}

    function EqualTo (AnEntry, Entry2 : Entry) : Boolean;
    {
     ।,   AnEntry  Entry2
      祢 .
     ।᫮ :  AnEntry  Entry2 ।.
     ᫮ :  頥 True, ᫨ 祢 
     ᮢ;  頥 False.
    }
    begin {EqualTo}
      EqualTo := (AnEntry.Name = Entry2.Name)
    end; {EqualTo}

    procedure DisplayEntry (AnEntry {室} : Entry);
    {
     뢮 ᮤন 㭪 ࠢ筨.
     ।᫮ : 祭 AnEntry ।.
     ᫮ : 뢮   ⥫䮭 .
    }
    begin {DisplayEntry}
      WriteLn (AnEntry.Name);
      WriteLn (AnEntry.Number)
    end; {DisplayEntry}

end. {EntryADT}

