unit StackADT;
{
 ন ᠭ ꥪ⮢ ⨯ Stack  
 ⮤: Init. Push, Pop, Retrieve, IsEmpty.
}
interface
  uses StackDataADT;  { ⨯ StackData}

  type
    StackPointer = ^StackNode;
    StackNode = record
                  Info : StackData;     {. }
                  Link : StackPointer;  {뫪 
                                    ᫥騩 㧥}
                end;  {StackNode}
    Stack = object
              constructor Init;
              procedure Push (X : StackData);
              procedure Pop (var X : StackData;
                             var Success : Boolean);
              procedure Retrieve (var X : StackData,
                                  var Success:Boolean);
              function IsEmpty : Boolean;
              destructor Done;

            private
              Top : StackPointer;    {㪠⥫ 
                                          ⥪}
            end;  {Stack}

implementation

constructor StackADT
{
   ⮩ ⥪.
  ।᫮ : .
  ᫮ : ⮩ ⥪ ᮧ..
}
begin {Init}
  Top := nil  {⥫,   㪠뢠 
                ⥪, ᢠ 祭 nil}
end;  {Init}

procedure Push.Stack (X {室} : StackData);
{
    ⥪ 祭 X.
  ।᫮ : 祭 X ।.
  ᫮ : Top^.Info ᮤন 祭 X.
}
  var OldTop : StackPointer; {㪠⥫  ।騩
                                            ⥪}

begin {Push}
  OldTop := Top;        {࠭ 㪠⥫ 
                                     ⥪.}
  New (Top);            {  㧫.}
  Top^.Info := X;       {ᥭ   㧥
                                          祭 X.}
  Top^.Link := OldTop   {  㧫
                                            ⥪.}
end;  {Push}

procedure Stack.Pop (var X {室} : StackData;
                     var Success {室} : Boolean);
{
  祭, ᮤঠ饥  ⥪, 
   ࠬ X.
  ।᫮ : ⥪ ᮧ.
  ᫮ : ন ࠬ X ᮢ 
                祭, ᮤঠ騬  ⥪;
                ᫥ ⮣ 祭  㤠 
                ⥪. ࠬ Success ⠭
                ⠪, ⮡ 㪠뢠 १ 樨
                祭  ⥪ 祭:
                 True ( 砥 ᯥ)   False
                ( 㤠).
}
  var
    OldTop : StackPointer;    {㪠⥫  ।騩
                                    孨 㧥 ⥪}

begin (Pop)
  if Top = nil then
    Success := False
  else
    begin
      0ldTop := Top;         {㪠⥫  ।騩
                                            ⥪}
      X := Top^.Info;        {祭  ⥪
                                         }
      Top := Top^.Link;      {㪠⥫   ⥪
                         ᢠ  祭}
      Dispose (OldTop);      {, ᯮ㥬
                           㧫, 頥  }
      Success := True
    end {if}
end; {Pop}

function Stack.IsEmpty : Boolean;
{
  ।᫮ : ⥪ ᮧ.
  ᫮ ; 頥 True ᫨ ⥪ ;
                 ⨢ 砥 頥 False.
}
begin {IsEmpty}
  IsEmpty := (Top = nil)
end; {IsEmpty}

  { ᫥ ⠢ ⮤ Retrieve  Done.}

end. {StackADT}

