      program WritePayroll (Output, InEmp, OutEmp);
      {
        뢠  室 䠩   稭 ௫
         ࠡ⭨,  ⠪ 㬬 
        ௫ .
      }
        var
          InEmp,              {䠩  室묨 묨}
          OutEmp : Text;      {室 䠩}
          Payroll : Real;     {㬬ୠ ௫ }


         procedure CopyLine (var Indata {input},
                                 OutData {output} : Text);
         {
          Copies a line of file InData to file OutData.
          Pre : InData is opened for input and OutData for output.
          Post: Next line of InData is written to OutData.
                The last character processed in InData is <eoln>;
                The last character written to OutData is <eoln>.
         }
           var
             NextCh : Char;      {each data character}

         begin {CopyLine}
           {Copy all data characters from InData to OutData.}
           while not EOLN(InData) do
             begin
               Read (InData, NextCh);  
               Write (OutData, NextCh)
             end; {while}

           {Process the <eoln> }
           ReadLn (InData);  
           WriteLn (OutData)
         end; {CopyLine}

        function UpCase (Ch : Char) : Char;
        {
         頥 ᢮ 㬥   ய᭮ 㪢.
         Pre : 
         Post: 頥 ய 㪢, 
               ᢮ 㬥, ᫨  ।⠢ ᮡ
                㪢;  ⨢ 砥 頥
               祭 㬥  .
        }
        begin {UpCase}
          if (Ch >= 'a') and (Ch <= 'z') then
            UpCase := Chr(Ord(Ch) - Ord('a')+Ord('A'))
          else
            UpCase := Ch
        end; {UpCase}
        
        procedure ReadData (var InEmp {室 䠩} : Text;
                            var HourOrSal {뢮} : Char;
                            var Rate {뢮},
                                Hours {뢮} : Real);
        {
         뢠   ௫  㦠饣.
         Pre :  InEmp 뢠  뢠.
         Post: HourOrSal ᮤন  ᨬ ப
               . ᫨ 祭 HourOrSal ᮮ⢥
               H, Rate ᮤন   ᮢ ,
                Hours ᮤন ⢮ ࠡ⠭ ᮢ.
               ᫨ 祭 HourOrSal ᮮ⢥ S, Rate
               ᮤন  ⠢,  Rate 
               । 祭.   
                祭 Hours  Rate  ।.
        }
        begin {ReadData}
          Read (InEmp, HourOrSal);
          HourOrSal := UpCase (HourOrSal);
          if HourOrSal = 'H' then
            ReadLn (InEmp, Rate, Hours)    {ᮢ ⠢  }
          else if HourOrSal = 'S' then
            ReadLn (InEmp, Rate)           { ⠢}
          else
            begin
              ReadLn (InEmp);
              Write ('४ ᨬ ', HourOrSal)
            end {if}
        end; {ReadData}
        
        function ComputeSal (HourOrSal : Char;
                             Rate,
                             Hours : Real) : Real;
        {
          ࠧ 쭮 ௫.
         Pre : HourOrSal  Rate ।.
         Post: ᫨ 祭 HourOrSal ᮮ⢥ H,
               頥 १ Rate * Hours.
               ᫨ 祭 HourOrSal ᮮ⢥ S,
               頥 १ Rate / 52.
                  १ ।.
        }
        begin {ComputeSal}
          if HourOrSal = 'H' then
            ComputeSal := Rate * Hours
          else if HourOrSal = 'S' then
            ComputeSal := Rate / 52.0
        end; {ComputeSal}

        procedure ProcessEmp (var InEmp {室 䠩},
                                  OutEmp {室 䠩} : Text;
                              var Payroll {뢮} : Real);
        {
         ࠡ뢠   㦠    㬬.
         Pre : InpEmp  OutEmp ⮢  -뢮.
         Post:   㦠   InEmp  OutEmp 
               㬬  ௫ 頥 १ ࠬ Payroll.
         뢠: 楤 CopyLine
        }
          var
            HourOrSal : Char;   { - 祭   S}
            Hours,              { - ࠡ⠭ }
            Rate,               { - ᮢ ⠢}
            Salary : Real;      {뢮 - 㬬ୠ ௫}

        begin  {ProcessEmp}
          Payroll := 0.0;
          while not EOF(InEmp) do
            begin
              CopyLine (InEmp, OutEmp);        {஢ .}
              {뢠   ௫.}
              ReadData (InEmp, HourOrSal, Rate, Hours);
              Salary := ComputeSal (HourOrSal, Rate, Hours);
              if (HourOrSal = 'H') or (HourOrSal = 'S') then
                begin {४ }
                  Payroll := Payroll+Salary;
                  WriteLn (OutEmp, Salary :4:2)
                end {४ }
              else
                WriteLn (OutEmp, '௫  ।')
            end  {while}
        end; {ProcessEmp}

      begin {WritePayroll}
        {樨஢ 䠩 ६
          䠩  ᪥.}
        Assign (InEmp, 'A:\INEMP.DAT');
        Assign (OutEmp, 'A:\OUTEMP.DAT');

        {⮢ 䠩 InEmp  OutEmp}
        Reset (InEmp);
        Rewrite (OutEmp);

        {ࠡ⪠   㦠 
         ᫥ 㬬୮ ௫.}
        ProcessEmp (InEmp, OutEmp, Payroll);

        {뢮 १⮢  ⨥ 䠩}
        WriteLn ('㬬ୠ ௫ $', Payroll :4:2);
        Close (InEmp);
        Close (OutEmp)
      end. {WritePayroll}
