procedure BinSearch (var Table {室} : IntArray;
                         Target {室} : Integer;
                         First, Last {室} : Integer;
                     var Index {室} : Integer;
                     var Found {室} : Boolean);
{
  Pre :  Table ᯮ  ⠭
         祭 First  Last ।.
  Post: ᫨ Target   ᨢ, 㭪
          ⮯ १ ࠬ
        Index  ⠭ ࠬ Found  True;
         ⨢ 砥 Found 㤥 ⠭ 
        False,  祭 Index ⠭
        ।.
}
  var
    Middle : Integer;
begin {BinSearch}
  Middle := (First + Last) div 2;  {। .}
  if First > Last then             { ࠭.}
    Found := False
  else if Target = Table[Middle] then
    begin
      Found := True;               {ᯥ }
      Index := Middle
    end
  else if Target < Table[Middle] then
    BinSearch(Table, Target, First, Middle - 1,
              Index, Found)
  else
    BinSearch(Table, Target, Middle + 1, Last,
              Index, Found)
end; {BinSearch}
