program Concordance;
{
    뢮 ᫮ ७  㪢
   ப.   ࠥ ஫. 㪢, 騥
   ࠧ,  뢮.
}
  type
    Letter = 'A'..'Z';
    CountArray = array [Letter] of Integer;

  var
    LetterCount : CountArray;       {室 - ᨢ ७}

  procedure FillCountArray (var W {室} : CountArray;
                            InValue {室} : Integer);
  {
   樠   ᢮ ࠬ-ᨢ
   祭 InValue.
   Pre  : 祭 InValue .
   Post :    ࠬ-ᨢ 
          祭 InValue.
  }

    var
      I : Char;

  begin {FillCountArray}
   for I := 'A' to 'Z' do
       W[I] := InValue
  end; {FillCountArray}

  function UpCase (Ch : Char) : Char;
  {
   頥 ய 㪢, ᮮ⢥ Ch.
   Pre : Ch  । 祭.
   Post: ᫨ 祭 Ch -- 筠 㪢,
         頥 ᮮ⢥ ய 㪢;
          ⨢ 砥 頥 祭 Ch.
  }
  begin {UpCase}
    if Ch in ['a'..'z'] then
      UpCase := Chr(Ord(Ch) - Ord('a') + Ord('A'))
    else
      UpCase := Ch
  end; {UpCase}

  procedure CountLetters
          (var LetterCount {室} : CountArray);
  {
   뢠 ᫮ ७  㪢.
   Pre : ᨢ LetterCount 樠 ﬨ.
   Post: 뢠 ப  LetterCount[Ch] ᮤন
         ᫮ ७ 㪢 Ch  ப.
  }
    var
      Ch : Char;                  { ᨬ ப}

  begin {CountLetters}
    WriteLn (' ப:');
    while not EOLN do
      begin
        Read (Ch);                {騩 ᨬ.}
        Ch := UpCase (Ch);  {८ࠧ  ய.}
        if (Ch >= 'A') and (Ch <= 'Z') then
          LetterCount[Ch] := LetterCount[Ch] + 1
      end; {while}
    ReadLn                        {ய <eoln>.}
  end; {CountLetters}

  procedure PrintCount (LetterCount {室} : CountArray);
  {
   뢮   塞  㪢 
    ப.
   Pre : ᨢ LetterCount 樠஢.
   Post: 뢮  㪢  㪠뢠, ᪮쪮
         ࠧ   ப  .
  }
  var
    NextChar : Letter;      {ࠢ 横
                             ६   ᨢ}

  begin {PrintCount}
    WriteLn;
    WriteLn ('㪢', '७' :16);
    for NextChar := 'A' to 'Z' do
      if LetterCount[NextChar] > 0 then
        WriteLn (NextChar :5, LetterCount[NextChar] :16)
  end; {PrintCount}

begin {Concordance}
  {樠 ᨢ LetterCount.}
  FillCountArray (LetterCount, 0);

  { 㪢  ப.}
  CountLetters (LetterCount);

  {뢮 १⮢.}
  PrintCount (LetterCount)
end. {Concordance}
