unit EntryObjADT;
{
 ࠪ ⨯   㭪 ⥫䮭
 ࠢ筨,   ꥪ.
}
interface

  {⠢  ᠭ ꥪ⮢ ⨯ Entry.
   . . 13.5.}

implementation

  procedure Entry.Init (AName: KeyType;
                        ANumber : StringType);
  {
    祭 AName  ANumber   㭪.
   ।᫮ : AName  ANumber ।.
   ᫮ : AName  ANumber   㭪 ࠢ筨.
  }
  begin {Init}
    Name := AName;
    Number := ANumber
  end; {Init}

  procedure Entry.ReadEntry (var InFile : Text;
                             FileName : string);
  {
   뢠  㭪 ࠢ筨 ⥫䮭 .
   ।᫮ :  InFile   祭 FileName ।.
   ᫮ :   ⥫䮭  뢠  㭪 ࠢ筨.
  }
  begin {ReadEntry}
    if FileName = '' then
      begin { }
        Write ('> ');
        ReadLn (Name);
        Write ('> ');
        ReadLn (Number)
      end { }
    else
      begin { InFile}
        ReadLn (InFile, Name);
        ReadLn (InFile, Number)
      end { InFile}
  end; {ReadEntry}

  function Entry.GetNumber : StringType;
  {
   頥 ⥫䮭 , ᮤঠ騩  㭪 ࠢ筨.
   ।᫮ : 㭪 ࠢ筨 ।.
   ᫮ : 頥 ᮮ⢥騩 ⥫䮭 .
  }
  begin {GetNumber}
    GetNumber := Number
  end; {GetNumber}

  function Entry.GetName : KeyType;
  {
   頥 , ᮤঠ饥  㭪 ࠢ筨.
   ।᫮ : 㭪 ।.
   ᫮ : 頥 .
  }
  begin {GetName}
    GetName := Name
  end; {GetName}

  function Entry.EqualTo (Entry2 : Entry) : Boolean;
  {
   ।, ᮢ  祢   樯
    ࠬ Entry2.
   ।᫮ : 樯  Entry2 ।.
   ᫮ : 頥 True, ᫨ 祢 
                 樯  Entry2 ᮢ;
                  ⨢ 砥 頥 False.
  }
  begin {EqualTo}
    EqualTo := (Self.Name = Entry2.Name)
  end; {EqualTo}

  procedure Entry.DisplayEntry;
  {
   뢮 ᮤন 㭪.
   ।᫮ : 㭪 ।.
   ᫮ : 뢮   .
  }
  begin {DisplayEntry}
    WriteLn (Name);
    WriteLn (Number)
  end; {DisplayEntry}

end. {EntryObjADT}
