{$R+}
program HomeBudget;
{⠥ ⮣ 室  ᥬ ⥣ .}

uses
  BudgetCatADT;   { ⨯ BudgetCat,  ⠪
                   ணࠬ ReadBudgetCat 
                   WriteBudgetCat.}
  type
    BudgetArray = array [BudgetCat] of Real;
                                        {⨯-ᨢ}

  var
    Budget : BudgetArray;    {室 - ᨢ ⮣}

  procedure Initialize (var Budget {室} : BudgetArray);
  {
   樠 ﬨ ᨢ Budget.
   Pre : .
   Post:   ᨢ Budget
         ᮤন 祭 0.0.
  }
    var
      NextCat : BudgetCat;         {ࠢ 横}
                                   {    ᨢ}
  begin {Initialize}
    for NextCat := Entertainment to Miscellaneous do
    Budget[NextCat] := 0.0
  end; {Initialize}

  procedure DisplayMenu;
  {⮡ࠦ ⥣ਨ .}
    var
      NextCat : BudgetCat;

  begin
    WriteLn (' :');
    for NextCat := Entertainment to Done do
      begin
        WriteBudgetCat (NextCat);
        WriteLn
      end; {for}
      WriteLn
  end; {DisplayMenu}

  procedure PostIt (var Budget {室/室} : BudgetArray);
  {
    뢠 稭  室   
     祭 ᮮ⢥饣  ᨢ Budget.
    Pre : 祭   ᨢ
          Budget[NextCat] ࠢ 0.0.
    Post: 祭   ᨢ
          Budget[NextCat] ᮮ⢥ 㬬 室
           ⥣ਨ NextCat.
  }

    var
      NextCat : BudgetCat;      {᫥ ⥣}
      Expense : Real;           {稭 室}

  begin  {PostIt}
    {뢠  ⥣ਨ  
     ᮮ⢥騩 室,  ⥬   
     祭 ᮮ⢥饣  ᨢ Budget.}
    ReadBudgetCat (NextCat);
    while  NextCat <> Done do
      {ਠ:
          ⮣ ६ Choice   祭
         Done  Budget[NextCat] ।⠢ ᮡ
         㬬 । 室  ⥣ਨ NextCat.
      }
      begin
        Write (' 稭 室 $');
        ReadLn (Expense);  WriteLn;
        Budget[NextCat] := Budget[NextCat] + Expense;
        ReadBudgetCat (NextCat)
      end {while }
  end; {PostIt}

  procedure Report (Budget {室} : BudgetArray);
  {
    ⠥ 稭 室   ⥣ਨ
    .
    Pre  : ᨢ Budget ।.
    Post : ⮡ࠦ   ⥣ਨ 
            ᮮ⢥饣 祭.
    Calls: WriteBudgetCat
  }
    var
      NextCat : BudgetCat;    {ࠢ 横}
                              { ᨢ}
  begin {Report}
    WriteLn;               {뢮 "蠯" ⠡.}
    WriteLn ('  ⥣     ' :15,  '室' :12);
    {   ⥣ਨ  ⮣.}
    for NextCat := Entertainment to Miscellaneous do
     begin
       WriteBudgetCat (NextCat);   {뢮 ⥣ਨ.}
       WriteLn (Budget[NextCat] :15:2)
     end {for}
  end; {Report}

begin  {HomeBudget}

  {樠 ᨢ Budget ﬨ.}
  Initialize (Budget);

  {뢮  ⥣਩ .}
  DisplayMenu;

  {뢠  ࠡ⪠  室.}
  PostIt (Budget);

  { 室  ⥣.}
  Report (Budget)
end. {HomeBudget}
